diff -urN linux-vgl/kernel/sched.c linux-ml-vdr/kernel/sched.c
--- linux-vgl/kernel/sched.c	Fri Dec 21 18:42:04 2001
+++ linux-ml-vdr/kernel/sched.c	Thu Apr  4 21:58:22 2002
@@ -43,6 +43,10 @@
 
 unsigned securebits = SECUREBITS_DEFAULT; /* systemwide security settings */
 
+/* ML */
+unsigned short schedcount = 1;
+
+
 extern void mem_use(void);
 
 /*
@@ -183,6 +187,13 @@
 		goto out;
 	}
 
+/* ML */
+	if (p->policy == SCHED_VDR) {
+		weight = 100 + p->counter;
+		goto out;
+	}
+
+
 	/*
 	 * Realtime process, select the first one on the
 	 * runqueue (taking priorities within processes
@@ -609,11 +620,23 @@
 		p = list_entry(tmp, struct task_struct, run_list);
 		if (can_schedule(p, this_cpu)) {
 			int weight = goodness(p, this_cpu, prev->active_mm);
+/* ML */
+			if ( (weight < 100 || weight >=1000 ) || ((schedcount)) ) {
+
+
 			if (weight > c)
 				c = weight, next = p;
+/* ML */
+			}
+
+
 		}
 	}
 
+/* ML */
+	if (c >= 100 && c < 1000) {schedcount--;} else {schedcount = 3;}
+
+
 	/* Do we need to re-calculate counters? */
 	if (unlikely(!c)) {
 		struct task_struct *p;
@@ -930,7 +953,11 @@
 	else {
 		retval = -EINVAL;
 		if (policy != SCHED_FIFO && policy != SCHED_RR &&
-				policy != SCHED_OTHER)
+/* ML */
+/*				policy != SCHED_OTHER) */
+				policy != SCHED_OTHER && policy != SCHED_VDR)
+
+
 			goto out_unlock;
 	}
 	
@@ -941,7 +968,11 @@
 	retval = -EINVAL;
 	if (lp.sched_priority < 0 || lp.sched_priority > 99)
 		goto out_unlock;
-	if ((policy == SCHED_OTHER) != (lp.sched_priority == 0))
+/* ML */
+/*	if ((policy == SCHED_OTHER) != (lp.sched_priority == 0)) */
+	if ((policy == SCHED_OTHER || policy == SCHED_VDR) != (lp.sched_priority == 0))
+
+
 		goto out_unlock;
 
 	retval = -EPERM;

diff -urN linux-vgl/kernel/timer.c linux-ml-vdr/kernel/timer.c
--- linux-vgl/kernel/timer.c	Mon Oct  8 19:41:41 2001
+++ linux-ml-vdr/kernel/timer.c	Thu Apr  4 21:30:37 2002
@@ -813,7 +813,11 @@
 
 
 	if (t.tv_sec == 0 && t.tv_nsec <= 2000000L &&
-	    current->policy != SCHED_OTHER)
+/* ML */
+/*	    	    current->policy != SCHED_OTHER) */
+	    (current->policy != SCHED_OTHER && current->policy != SCHED_VDR))
+
+
 	{
 		/*
 		 * Short delay requests up to 2 ms will be handled with
diff -urN linux-vgl/include/linux/sched.h linux-ml-vdr/include/linux/sched.h
--- linux-vgl/include/linux/sched.h	Fri Dec 21 18:42:03 2001
+++ linux-ml-vdr/include/linux/sched.h	Thu Apr  4 21:28:36 2002
@@ -116,6 +116,10 @@
 #define SCHED_FIFO		1
 #define SCHED_RR		2
 
+/* ML */
+#define SCHED_VDR		4
+
+
 /*
  * This is an additional bit set when we want to
  * yield the CPU for one re-schedule..
